diff -Naur newlib-1.20.0.orig/libgloss/epiphany/epiphany-config.h newlib-1.20.0/libgloss/epiphany/epiphany-config.h
--- newlib-1.20.0.orig/libgloss/epiphany/epiphany-config.h	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/epiphany-config.h	2012-03-28 10:11:12.211137937 +0200
@@ -0,0 +1,67 @@
+/* EPIPHANY builtin and configuration functions ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#ifndef _EPIPHANY_CONFIG_H
+#define _EPIPHANY_CONFIG_H
+
+
+extern unsigned _stack_start_;
+extern unsigned _heap_start_;
+extern unsigned _heap_end_;
+extern unsigned _CORE_NUM_;
+
+
+
+
+
+enum ECORE_SIGNALS {
+#ifndef 	SIG_DFL
+   SIG_DFL=0,
+#endif
+#ifndef 	SIG_DFL
+   SIG_IGN=1,
+#endif
+   SIG_RESET=3,
+   SIG_SW_EXCEPTION=4,
+   SIG_PAGE_MISS=5,
+   SIG_TIMER0=6,
+   SIG_TIMER1=7,
+   SIG_MESSAGE=8,
+   SIG_DMA0=9,
+   SIG_DMA1=10,
+   SIG_WAND=11,
+   SIG_USR1=12
+#ifndef 	SIG_ERR
+   , SIG_ERR=-1
+#endif
+};
+
+
+
+#endif
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/epiphany-ivthandlers.S newlib-1.20.0/libgloss/epiphany/epiphany-ivthandlers.S
--- newlib-1.20.0.orig/libgloss/epiphany/epiphany-ivthandlers.S	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/epiphany-ivthandlers.S	2012-03-28 10:11:12.211137937 +0200
@@ -0,0 +1,192 @@
+# EPIPHANY implementation of wrappers over user C ISR ()
+
+# Copyright (c) 2011, Adapteva, Inc.
+# All rights reserved.
+
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#  * Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#  * Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#  * Neither the name of Adapteva nor the names of its contributors may be
+#    used to endorse or promote products derived from this software without
+#    specific prior written permission.
+
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+.section RESERVED_CRT0,"a",@progbits     ;
+.set sw_exception_v_n, 1
+.set page_miss_v_n, 2
+.set timer0_expired_v_n, 3;
+.set timer1_expired_v_n, 4;
+.set message_v_n, 5;
+.set dma0_v_n, 6;
+.set dma1_v_n, 7;
+.set wand_v_n, 8;
+.set soft_v_n, 9
+
+// preserve isr-mods to ACTIVE, GID, KERNEL, WAND, & EXCAUSE bits in the status reg
+.set status_mask, 0x0007000f;
+// for the wand isr, preserve isr-mods to ACTIVE, GID, KERNEL, & EXCAUSE, but
+// clear the WAND bit.
+.set wand_status_mask, 0x00070007;
+
+//IVT wrappers
+
+.global _DEFAULT_ISR_CALLBACK;
+.balign 4
+.type   _DEFAULT_ISR_CALLBACK, %function
+_DEFAULT_ISR_CALLBACK:
+	rts
+.size  _DEFAULT_ISR_CALLBACK, .-_DEFAULT_ISR_CALLBACK
+
+
+.global _DEFAULT_ISR_CALLBACK_FOR_sw_exception_v;
+.balign 4
+.type   _DEFAULT_ISR_CALLBACK_FOR_sw_exception_v, %function
+_DEFAULT_ISR_CALLBACK_FOR_sw_exception_v:
+	trap 5;; FAIL
+.size  _DEFAULT_ISR_CALLBACK_FOR_sw_exception_v, .-_DEFAULT_ISR_CALLBACK_FOR_sw_exception_v
+
+
+.set NUMBER_ENTRIES_IN_IVT, 8
+.global _ISR_VECTOR;
+.balign 4
+.type   _ISR_VECTOR, %object
+_ISR_VECTOR:
+	.word _DEFAULT_ISR_CALLBACK_FOR_sw_exception_v; reset
+	.word _DEFAULT_ISR_CALLBACK_FOR_sw_exception_v; sw_exception
+	.word _DEFAULT_ISR_CALLBACK_FOR_sw_exception_v; page_miss
+	.rept   NUMBER_ENTRIES_IN_IVT
+		.word _DEFAULT_ISR_CALLBACK
+	.endr
+.size  _ISR_VECTOR, .-_ISR_VECTOR
+
+.macro IVT_ENTRY_CALL entry_v_
+	;; assuming we have valid frame poiter
+
+	str fp, [sp],-0x10
+	str r0, [sp,+0xf]
+	str r1, [sp,+0xe]
+	mov r0, \entry_v_
+.if \entry_v_ == wand_v_n
+	mov   r1, %low(wand_status_mask)  ; this mask will exclude WAND, so it will
+	movt  r1, %high(wand_status_mask) ; be forcibly cleared
+.else
+	mov   r1, %low(status_mask)
+	movt  r1, %high(status_mask)
+.endif
+	str r1, [sp,0x9] ; save the status register isr-preserve mask on the stack
+	b   __dispatcher
+.endm
+
+.global __dispatcher;
+.balign 4
+.type   __dispatcher, %function
+__dispatcher:
+	str lr, [sp,+0xd]
+	movfs.l r1,status
+	str r1, [sp,+0xc]
+	movfs.l r1,iret
+	str r1, [sp,+0xb]
+	str r2, [sp,+0xa]
+	str r3, [sp,+0x8]
+
+	mov fp,sp
+
+	//TODO allow nesting
+	//gie
+
+	lsl r2, r0, 2
+	mov	r1, %low(_ISR_VECTOR)
+	add r2, r2, r1
+	ldr r1, [r2,0] ;; r1 = _ISR_VECTOR[entry_v]
+	mov r2, 3
+	add r0, r0, r2 ;; r0 = signum
+	jalr r1
+
+	mov sp,fp
+
+	//gid
+
+	// preserve isr-modifications to some of the bits in the status register,
+	// but restore the rest to pre-interrupt values.
+	// status = (status[post_isr] & status_mask) | (status[pre_isr] & ~status_mask)
+
+	ldr.l r2, [sp, 9] ; fetch the status register isr preserve mask from the stack
+	movfs r1, status
+	and   r1, r1, r2; (status[post_isr] & status_mask)
+
+	ldr  r0, [sp,+0xc]
+	mov  r2, %low(~status_mask)
+	movt r2, %high(~status_mask)
+	and  r0, r0, r2; (status[pre_isr] & ~status_mask)
+
+	orr r0, r0, r1 ; combine pre_isr & post_isr status bits
+	movts.l status, r0
+
+	ldr r0, [sp,+0xb]
+	movts.l iret,r0
+
+	ldr  lr,[sp,+0xd];
+	ldr  r1,[sp,+0xe]
+	ldr  r0,[sp,+0xf]
+	ldr  r2,[sp,+0xa]
+	ldr  r3,[sp,+0x8]
+	ldr  fp,[sp],+0x10
+	ldr  fp,[sp,0]
+	rti
+.size  __dispatcher, .-__dispatcher
+
+
+.global .sw_exception_v;
+.type   .sw_exception_v, %function
+.sw_exception_v:
+	IVT_ENTRY_CALL sw_exception_v_n;
+.size  .sw_exception_v, .-.sw_exception_v
+
+.global .page_miss_v;
+.type   .page_miss_v, %function
+.page_miss_v:
+	IVT_ENTRY_CALL page_miss_v_n;
+.size  .page_miss_v, .-.page_miss_v
+
+.global .timer0_expired_v;
+.timer0_expired_v:
+	IVT_ENTRY_CALL timer0_expired_v_n;
+
+.global .timer1_expired_v;
+.timer1_expired_v:
+	IVT_ENTRY_CALL timer1_expired_v_n;
+
+.global .message_v;
+.message_v:
+	IVT_ENTRY_CALL message_v_n;
+
+.global .dma0_v;
+.dma0_v:
+	IVT_ENTRY_CALL dma0_v_n;
+
+.global .dma1_v;
+.dma1_v:
+	IVT_ENTRY_CALL dma1_v_n;
+
+.global .wand_v;
+.wand_v:
+	IVT_ENTRY_CALL wand_v_n;
+
+.global .soft_v;
+.soft_v:
+	IVT_ENTRY_CALL soft_v_n;
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/epiphany-syscalls.c newlib-1.20.0/libgloss/epiphany/epiphany-syscalls.c
--- newlib-1.20.0.orig/libgloss/epiphany/epiphany-syscalls.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/epiphany-syscalls.c	2012-03-28 10:11:12.211137937 +0200
@@ -0,0 +1,271 @@
+/* Adapteva epiphany-core implementation of stdio support functions ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+#include <errno.h>
+
+/* simple include interface to EPIPHANY trap instruction. */
+
+/*
+ * The simulator uses a trap instruction to escape to the simulator to do file i/o
+ */
+
+/*      trapcode             r0            r1             r2  */
+#define TRAP_write 0  /*    channel        addr           len */
+#define TRAP_read 1   /*    channel        addr           len */
+#define TRAP_open 2   /*    filepath       mode               */
+#define TRAP_exit 3   /*    status                            */
+#define TRAP_pass 4   /*     -                                */
+#define TRAP_fail 5   /*     -                                */
+#define TRAP_close 6  /*    channel                           */
+#define TRAP_other 7  /*    subcode        r1              r2 */
+
+
+#include "epiphany-syscalls.h"
+
+
+/* prototypical inline asm */
+int __attribute__ ((section ("libgloss_epiphany")))  asm_write (int CHAN, void* ADDR, int LEN)
+{
+	register int chan asm("r0") = CHAN;
+	register void* addr asm("r1") = ADDR;
+	register int len asm("r2") = LEN;
+	register int result asm("r0");
+	register int error asm("r3");
+	asm ("trap 0" : "=r" (result), "=r" (error) :
+	     "r" (chan), "r" (addr), "r" (len));
+	if (error)
+	  errno = error;
+	return result;
+}
+
+int __attribute__ ((section ("libgloss_epiphany")))  asm_read(int CHAN, void *ADDR, int LEN)
+{
+	register int chan asm("r0") = CHAN;
+	register void* addr asm("r1") = ADDR;
+	register int len asm("r2") = LEN;
+	register int result asm("r0");
+	register int error asm("r3");
+	asm ("trap 1" : "=r" (result), "=r" (error) :
+	     "r" (chan), "r" (addr), "r" (len));
+	if (error)
+	  errno = error;
+	return result;
+}
+
+
+int __attribute__ ((section ("libgloss_epiphany")))
+asm_open(const char* FILE, int FLAGS, int MODE)
+{
+	register const char* file asm("r0") = FILE;
+	register int flags asm("r1") = FLAGS;
+	register int result asm("r0");
+	register int error asm("r3");
+	asm ("trap 2" : "=r" (result), "=r" (error) : "r" (file), "r" (flags));
+	if (error)
+	  errno = error;
+	return result;
+}
+
+void __attribute__ ((section ("libgloss_epiphany")))  asm_exit(int STATUS)
+{
+	register int status asm("r0") = STATUS;
+	asm("trap 3" :: "r" (status));
+}
+
+int __attribute__ ((section ("libgloss_epiphany")))  asm_close(int CHAN)
+{
+	register int chan asm("r0") = CHAN;
+	register int result asm("r0");
+	register int error asm("r3");
+	asm ("trap 6" : "=r" (result), "=r" (error) : "r" (chan));
+	if (error)
+	  errno = error;
+	return result;
+}
+
+int __attribute__ ((section ("libgloss_epiphany")))  asm_syscall(void *P1,void *P2, void *P3, int SUBFUN)
+{
+	register void* p1 asm("r0") = (void*)P1;
+	register void* p2 asm("r1") = (void*)P2;
+	register void* p3 asm("r2") = (void*)P3;
+	register int result asm("r0");
+	register int subfun asm("r3") = SUBFUN;
+	register int error asm("r3");
+	asm ("trap 7" : "=r" (result), "=r" (error) :
+	     "r" (p1), "r" (p2), "r" (p3), "r" (subfun));
+	if (error)
+	  errno = error;
+	return result;
+}
+
+/*
+ * Signal functions implementation
+ *
+ */
+
+#include "epiphany-config.h"
+
+
+#define HW_RESET 0
+#define SW_EXCEPTION_IVT_N 1
+#define PAGE_MISS_IVT_N 2
+#define TIMER0_IVT_N 3
+#define TIMER1_IVT_N 4
+#define MESSAGE_IVT_N 5
+#define DMA0_IVT_N 6
+#define DMA1_IVT_N 7
+#define WAND_IVT_N 8
+#define USR_SOFT_IVT_N 9
+
+
+typedef void (*sighandler_t)(int);
+extern sighandler_t ISR_VECTOR[];
+extern void DEFAULT_ISR_CALLBACK();
+
+sighandler_t __attribute__ ((section ("libgloss_epiphany")))  signal(int signum, sighandler_t handler) {
+	switch( signum )
+	{
+	case SIG_DFL /* see signal.h */:
+		//the default is ignore
+		break;
+	case SIG_IGN /* see signal.h */ :
+		DEFAULT_ISR_CALLBACK();
+		break;
+	case SIG_ERR :
+		asm("trap 5");
+		break;
+	case SIG_RESET:
+		ISR_VECTOR[HW_RESET] = handler;
+		break;
+	case SIG_SW_EXCEPTION:
+		ISR_VECTOR[SW_EXCEPTION_IVT_N] = handler;
+		break;
+	case SIG_PAGE_MISS:
+		ISR_VECTOR[PAGE_MISS_IVT_N] = handler;
+		break;
+	case SIG_TIMER0:
+		ISR_VECTOR[TIMER0_IVT_N] = handler;
+		break;
+	case SIG_TIMER1:
+		ISR_VECTOR[TIMER1_IVT_N] = handler;
+		break;
+	case SIG_MESSAGE:
+		ISR_VECTOR[MESSAGE_IVT_N] = handler;
+		break;
+	case SIG_DMA0:
+		ISR_VECTOR[DMA0_IVT_N] = handler;
+		break;
+	case SIG_DMA1:
+		ISR_VECTOR[DMA1_IVT_N] = handler;
+		break;
+	case SIG_WAND:
+		ISR_VECTOR[WAND_IVT_N] = handler;
+		break;
+
+	case SIG_USR1:
+		ISR_VECTOR[USR_SOFT_IVT_N] = handler;
+		break;
+	default:
+		//do nothing
+		return 0;
+	}
+
+	return 0;
+}
+
+//int e_raise(int signum) __attribute__ ((optimize("O0")));
+
+int __attribute__ ((section ("libgloss_epiphany")))  e_raise(int signum) {
+
+	//register int imask asm("r4") = 0 ;
+	volatile register int ilatst /*asm("r5") */= signum;
+
+	switch( signum )
+	{
+	case SIG_DFL /* see signal.h */:
+		//the default is ignore
+		return 0;
+	case SIG_IGN /* see signal.h */ :
+		//do nothing
+		return 0;
+	case SIG_ERR :
+
+		return 0;
+	case SIG_RESET:
+		//imask = 1 << HW_RESET;
+		ilatst = 1 << HW_RESET;
+		break;
+
+	case SIG_SW_EXCEPTION:
+		//imask = 1 << SW_EXCEPTION_IVT_N;
+		ilatst = 1 << SW_EXCEPTION_IVT_N;
+		break;
+	case SIG_PAGE_MISS:
+		//imask = 1 << PAGE_MISS_IVT_N;
+		ilatst = 1 << PAGE_MISS_IVT_N;
+		break;
+	case SIG_TIMER0:
+		//imask = 1 << TIMER0_IVT_N;
+		ilatst = 1 << TIMER0_IVT_N;
+		break;
+	case SIG_TIMER1:
+		//imask = 1 << TIMER1_IVT_N;
+		ilatst = 1 << TIMER1_IVT_N;
+		break;
+	case SIG_MESSAGE:
+		//imask = 1 << MESSAGE_IVT_N;
+		ilatst = 1 << MESSAGE_IVT_N;
+		break;
+	case SIG_DMA0:
+		//imask = 1 << DMA0_IVT_N;
+		ilatst = 1 << DMA0_IVT_N;
+		break;
+	case SIG_DMA1:
+		//imask = 1 << DMA1_IVT_N;
+		ilatst = 1 << DMA1_IVT_N;
+		break;
+	case SIG_WAND:
+		__asm__ __volatile__ ("wand");
+		//ilatst = 1 << WAND_IVT_N;
+		//break;
+		return;
+
+	case SIG_USR1:
+		ilatst = 1 << USR_SOFT_IVT_N;
+		break;
+
+	default:
+		//do nothing
+		return 0;
+	}
+	//asm("movts imask, r4;");
+	//asm("movts ilatst, r5;");
+	__asm__ __volatile__ ("movts ilatst, %0"  : "=r" (ilatst) : "r" (ilatst));
+	return 0;
+
+}
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/epiphany-syscalls.h newlib-1.20.0/libgloss/epiphany/epiphany-syscalls.h
--- newlib-1.20.0.orig/libgloss/epiphany/epiphany-syscalls.h	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/epiphany-syscalls.h	2012-03-28 10:11:12.212137952 +0200
@@ -0,0 +1,39 @@
+/* Adapteva e-core implementation of stdio support functions ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+#ifndef __EPIPHANY_SIM_H_
+#define __EPIPHANY_SIM_H_
+
+int asm_write (int CHAN, void* ADDR, int LEN);
+int asm_read(int CHAN, void *ADDR, int LEN);
+int asm_open(const char* FILE, int FLAGS, int MODE);
+void asm_exit(int STATUS);
+int asm_close(int CHAN);
+int asm_syscall(void *P1, void *P2, void *P3, int SUBFUN);
+
+#endif
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/execve.c newlib-1.20.0/libgloss/epiphany/execve.c
--- newlib-1.20.0.orig/libgloss/epiphany/execve.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/execve.c	2012-03-28 10:11:12.212137952 +0200
@@ -0,0 +1,56 @@
+/* EPIPHANY implementation of _execve ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <errno.h>
+#include <sys/types.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Transfer control to a new process.
+
+   This is a minimal implementation, which always fails (there are no
+   processes)!
+
+   @todo  Is this a permissible errno?
+
+   @param[in] filename  The file to execute
+   @param[in] argv      Null terminated list of args to the program
+   @param[in] envp      Null terminated list of environment value pairs
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+int __attribute__ ((section ("libgloss_epiphany")))
+_execve (const char *filename, char * const argv[], char * const envp[])
+{
+  errno = ENOSYS;			/* We don't do processes */
+  return -1;
+
+}	/* _execve () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/_exit.c newlib-1.20.0/libgloss/epiphany/_exit.c
--- newlib-1.20.0.orig/libgloss/epiphany/_exit.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/_exit.c	2012-03-28 10:11:12.194137673 +0200
@@ -0,0 +1,46 @@
+/* EPIPHANY implementation of _exit ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+/* ------------------------------------------------------------------------- */
+#include "epiphany-syscalls.h"
+/* ------------------------------------------------------------------------- */
+
+
+/* ------------------------------------------------------------------------- */
+/*!Exit from execution
+
+   This is the interface to the CGEN simulation.
+
+   @param[in] rc  The return code                                            */
+/* ------------------------------------------------------------------------- */
+void __attribute__ ((section ("libgloss_epiphany")))
+_exit (int  rc)
+{
+  asm_exit (rc);
+}	/* _exit () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/_exit.S newlib-1.20.0/libgloss/epiphany/_exit.S
--- newlib-1.20.0.orig/libgloss/epiphany/_exit.S	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/_exit.S	2012-03-28 10:11:12.194137673 +0200
@@ -0,0 +1,35 @@
+# EPIPHANY implementation of _exit ()
+
+# Copyright (c) 2011, Adapteva, Inc.
+# All rights reserved.
+
+# Contributor Joern Rennecke <joern.rennecke@embecosm.com> for Adapteva Inc
+
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#  * Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#  * Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#  * Neither the name of Adapteva nor the names of its contributors may be
+#    used to endorse or promote products derived from this software without
+#    specific prior written permission.
+
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.                                               */
+
+	.section .text
+	.global	__exit
+__exit:
+    trap    #3              ; exit
+   	b __exit
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/fork.c newlib-1.20.0/libgloss/epiphany/fork.c
--- newlib-1.20.0.orig/libgloss/epiphany/fork.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/fork.c	2012-03-28 10:11:12.212137952 +0200
@@ -0,0 +1,52 @@
+/* EPIPHANY implementation of _fork ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <errno.h>
+#include <sys/types.h>
+
+/* ------------------------------------------------------------------------- */
+/*!Create a new process
+
+   This is a minimal implementation, which always fails, since we have no
+   processes.
+
+   @todo  Is this a permissible errno?
+
+   @return  pid of the child (returning the parent), 0 (returning in the
+            parent) on success, -1 on failure with an error code in errno.   */
+/* ------------------------------------------------------------------------- */
+pid_t __attribute__ ((section ("libgloss_epiphany")))
+_fork (void)
+{
+  errno = ENOSYS;
+  return -1;
+
+}	/* _fork () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/fstat.c newlib-1.20.0/libgloss/epiphany/fstat.c
--- newlib-1.20.0.orig/libgloss/epiphany/fstat.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/fstat.c	2012-03-28 10:11:12.213137968 +0200
@@ -0,0 +1,49 @@
+/* EPIPHANY implementation of _fstat ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <sys/stat.h>
+#include <syscall.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Status of an open file
+
+   @param[in]  fildes  File descriptor for which status is sought
+   @param[out] st      Structure for the status information
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+int __attribute__ ((section ("libgloss_epiphany")))
+_fstat (int fildes, struct stat *st)
+{
+  return asm_syscall (fildes, st, NULL, SYS_fstat);
+
+}	/* _fstat () */
